diff --git a/ent/src/yb/tools/yb-admin_cli_ent.cc b/ent/src/yb/tools/yb-admin_cli_ent.cc
index bae2e21f25a0..1e7c94d1ab0e 100644
--- a/ent/src/yb/tools/yb-admin_cli_ent.cc
+++ b/ent/src/yb/tools/yb-admin_cli_ent.cc
@@ -126,6 +126,15 @@ void ClusterAdminCli::RegisterCommandHandlers(ClusterAdminClientClass* client) {
               }
               return ClusterAdminCli::kInvalidArguments;
             }));
+
+        for (auto table : tables) {
+          if (table.is_cql_namespace() && table.is_system()) {
+            return STATUS(InvalidArgument,
+                          "Cannot create snapshot of YCQL system table",
+                          table.table_name());
+          }
+        }
+
         RETURN_NOT_OK_PREPEND(client->CreateSnapshot(tables, true, timeout_secs),
                               Substitute("Unable to create snapshot of tables: $0",
                                          yb::ToString(tables)));
diff --git a/src/yb/client/yb_table_name.h b/src/yb/client/yb_table_name.h
index df1d93d7d4b7..a98c5bc460e8 100644
--- a/src/yb/client/yb_table_name.h
+++ b/src/yb/client/yb_table_name.h
@@ -132,6 +132,10 @@ class YBTableName {
 
   bool is_system() const;
 
+  bool is_cql_namespace() const {
+    return namespace_type_ == YQL_DATABASE_CQL;
+  }
+
   bool is_redis_namespace() const {
     return namespace_type_ == YQL_DATABASE_REDIS;
   }
diff --git a/src/yb/tools/yb-admin-test.cc b/src/yb/tools/yb-admin-test.cc
index 19521f0d0f3e..b02f348789b7 100644
--- a/src/yb/tools/yb-admin-test.cc
+++ b/src/yb/tools/yb-admin-test.cc
@@ -438,6 +438,19 @@ TEST_F(AdminCliTest, TestSnapshotCreation) {
   output = ASSERT_RESULT(CallAdmin("list_snapshots", "SHOW_DETAILS"));
   ASSERT_NE(output.find(extra_table.table_name()), string::npos);
   ASSERT_NE(output.find(kTableName.table_name()), string::npos);
+
+  // Snapshot creation should be blocked for CQL system tables (which are virtual) but not for
+  // redis system tables (which are not).
+  const auto result = CallAdmin("create_snapshot", "system", "peers");
+  ASSERT_FALSE(result.ok());
+  ASSERT_TRUE(result.status().IsRuntimeError());
+  ASSERT_NE(result.status().ToUserMessage().find(
+      "Error running create_snapshot: Invalid argument"), std::string::npos);
+  ASSERT_NE(result.status().ToUserMessage().find(
+      "Cannot create snapshot of YCQL system table: peers"), std::string::npos);
+
+  ASSERT_OK(CallAdmin("setup_redis_table"));
+  ASSERT_OK(CallAdmin("create_snapshot", "system_redis", "redis"));
 }
 
 TEST_F(AdminCliTest, GetIsLoadBalancerIdle) {
